package cokr.xit.fims.epst.service.bean;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Component;

import cokr.xit.fims.cmmn.CmmnUtil;
import cokr.xit.fims.epst.EpostQuery;
import cokr.xit.fims.epst.EpostRcptDtl;
import cokr.xit.fims.epst.dao.EpostRcptDtlMapper;
import cokr.xit.foundation.component.AbstractBean;
import cokr.xit.foundation.data.DataObject;

/**전자우편 접수 상세 정보 관리 Bean
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-12-15	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Component("epostRcptDtlBean")
public class EpostRcptDtlBean extends AbstractBean {

	/** 전자우편 접수 상세 정보 DAO */
	@Resource(name = "epostRcptDtlMapper")
	private EpostRcptDtlMapper epostRcptDtlMapper;

	/**지정한 조건에 따라 전자우편 접수 상세 목록을 조회하여 반환한다.
	 * @param req 전자우편 접수 상세 조회 조건
	 * @return 전자우편 접수 상세 목록
	 */
	public List<DataObject> getEpostRcptDtlList(EpostQuery req) {
		// 사용 여부 확인
		if (req.getUseYn() == null) {
			req.setUseYn("Y");
		}
		// 삭제 여부 확인
		if (req.getDelYn() == null) {
			req.setDelYn("N");
		}
		// 정렬 확인
		if (req.getOrderBy() == null) {
			if (req.getBy() == null) {
				req.setOrderBy("REG_DT");
			} else {
				req.setOrderBy(CmmnUtil.convertCamelCaseToSnakeCase(req.getBy()));
			}
		}

		return epostRcptDtlMapper.selectEpostRcptDtlList(req);
	}

	/**지정한 조건에 따라 전자우편 접수 상세 객체들을 반환한다.
	 * @param req 전자우편 접수 상세 조회 조건
	 * @return 전자우편 접수 상세 객체 목록
	 */
	public List<EpostRcptDtl> getEpostRcptDtls(EpostQuery req) {
		return epostRcptDtlMapper.selectEpostRcptDtls(req);
	}

	/**일련번호
	 * @param req
	 * @return 전자우편 접수 등록 객체 목록
	 */
	public int getEpostSenderDetailSeq(String sndngYmd) {
		return epostRcptDtlMapper.selectEpostSenderDetailSeq(sndngYmd);
	}

	/**전자우편 접수 상세 정보를 등록한다.
	 * @param epostRcptDtl 전자우편 접수 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean create(EpostRcptDtl epostRcptDtl) {
		return epostRcptDtlMapper.insert(epostRcptDtl);
	}

	/**전자우편 접수 상세 정보를 수정한다.
	 * @param epostRcptDtl 전자우편 접수 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean update(EpostRcptDtl epostRcptDtl) {
		return epostRcptDtlMapper.update(epostRcptDtl);
	}

	/**전자우편 접수 상세 정보를 삭제한다.
	 * @param epostRcptDtl 전자우편 접수 상세
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	public boolean remove(EpostRcptDtl epostRcptDtl) {
		return epostRcptDtlMapper.delete(epostRcptDtl);
	}

}
